// game_menu.h

#define BLOODMENU_OFF     0
#define BLOODMENU_MAIN    1
#define BLOODMENU_QUIT    2
#define BLOODMENU_EPISODE 3
#define BLOODMENU_ESC     4 // calls main menu
#define BLOODMENU_DIFFUC  5
#define BLOODMENU_SAVEG   6

struct bloodDrips
{
	int x;
	int y;
};

struct saveGame_t
{
	int  gameVersion;
	char gameName[20];
	int  numOfSprites;
	int  health;
	int  armor;
	int  currWeapon;

	saveGame_t::saveGame_t(char gameName[20], int numOfSprites, int health, int armor, 
							int currWeapon)
	{
		gameVersion  = 2;
		gameName     = gameName;
		numOfSprites = numOfSprites;
		health       = health;
		armor        = armor;
		currWeapon   = currWeapon;
	}
};
 
class gameMenu_t : public Game
{
	public:
		gameMenu_t();
		void DrawMenu(void);
		void SetMenu(int menuID);
		boolean MenuActive(void);
	private:
		void menu_main(void);
		void menu_saveGame(void);
		void menu_quit(void);
		void menu_episode(void);
		void DrawBloodDrips(void);
		void DrawIcon(void);
		void FlushMenu(void);
		void ThisMenuMain(void);
		void menu_diffculty(void);

		int  menuitems;
		int  slot;
		int  tmpNum;

		int lastMenu;

		int pEpisode;
		int pDiffuculty;

		boolean handleEscape;

		int fontNum;

		typedef void (gameMenu_t::*m_function)(void);

		struct menuItems_t
		{
			string name;
			int x;
			int y;
		};

		menuItems_t *CreateBloodMenu(string name, void (gameMenu_t::*m_function)(void), int x, int y)
		{
			menuItems_t *thisMenu = new menuItems_t;

			thisMenu->name          = name;
		//	thisMenu->m_function    = m_function;
			thisMenu->x				= x;
			thisMenu->y				= y;

			thisMenuFunc.push_back(m_function);
			return thisMenu;
		}

		void AddItemToMenu(menuItems_t *thisItem);

		m_function thisFunc;

		vector<bloodDrips  *>       menuDrips;
		vector<menuItems_t *>       currentMenuItems;
		vector<m_function>			thisMenuFunc;
	protected:
		int currentMenu;
};

