// game_shared.cpp

#include "game.h"

int totalclock;

Game            *thisGame;
guiManager      *guimanager;
build_func_t    *build_func;
fileManager_t   *fileManager;
gameMenu_t      *menuManager;
soundManager_t  *soundManager;
actorManager_t  *actorManager;


// RunFrame
// Calls gamemain

int RunFrame(int totalclock)
{
	return thisGame->RunFrame(totalclock);
}

int GameShutdown()
{
	thisGame->Shutdown();
	return -1;
}

// Game_API
// Function that interacts with the build system

Game_Exports *Game_API(Game_Imports *gi)
{
	Game_Exports *ge = new Game_Exports;
	build_func       = new build_func_t;

	printf(GAME_BUILD);
	ge->RunFrame     = RunFrame;
	ge->GameShutdown = GameShutdown; 
	thisGame         = new Game();

	build_func->nextpage		= gi->nextpage;
	build_func->build_KeyDown	= gi->build_Keydown;
	build_func->Load_Pallete    = gi->Load_Pallete;
	build_func->rotatesprite    = gi->rotatesprite;
	build_func->clearview       = gi->clearview;
	build_func->loadboard       = gi->loadboard;
	build_func->SDL_Quit		= gi->SDL_Quit;
	build_func->Decrypt_Map     = gi->Decrypt_Map;
	build_func->displayLevel    = gi->displayLevel;
	build_func->P_Movecode      = gi->P_Movecode;
	build_func->clipmove        = gi->clipmove;
	build_func->mulscale		= gi->mulscale;
	build_func->pushmove		= gi->pushmove;
	build_func->ftotalclock     = gi->ftotalclock;
	build_func->Set_Brightness  = gi->Set_Brightness;
	build_func->getzrange		= gi->getzrange;
	build_func->Game_GetSprite  = gi->Game_GetSprite;
	build_func->Justin_SetSky   = gi->Justin_SetSky;
	build_func->build_ClearKey  = gi->build_ClearKey;
	memcpy(build_func->sintable,gi->sintable,2048);

	// Create our managers here...
	guimanager    = new guiManager;
    fileManager   = new fileManager_t();
	menuManager   = new gameMenu_t();
	soundManager  = new soundManager_t();
	actorManager  = new actorManager_t();
	return ge;
}