// script_runner.h

struct variable_t
{
	char *name;
	char *val;

	variable_t::variable_t(char *name, char *val)
	{
		this->name = name;
		this->val  = val;
	}
};

class script_runner
{
	private:
		void    ReadComment(void);
		boolean CheckToken(char *tokenIn);
		void    CompileScript(char *progBuffer, int progSize);
		void    RunCodeBlock(int start, int end);
		void    ExecConditional(void);

		vector<int>          compiledProg;
		vector<variable_t *> scriptVariables;

		int  progEntry;
	    int  progEnd;
		int  currentPosition;
		int  compiled_position;

		static char *punctuation[];
		static char *events[];

		int thisRand;

		int thisReloadAmount;

		boolean leave_program;
	public:
		char        *thisProgBuffer;

		int thisHealth;

		int spriteNum;

		script_runner::script_runner(string program)
		{
			this->program = program;
		}

		void Execute(void);
	private:
		string program;
		int    readBytes;
		char   *token;
};