// soundManager.cpp

#include "game.h"

soundManager_t::soundManager_t()
{
	printf("....loading sound system\n");
	FSOUND_Init(41000, 32, 0);
};

/*
====================================================
int soundManager_t::precache_Sound(char *filename)
====================================================
*/

int soundManager_t::precache_Sound(char *filename)
{
	FSOUND_SAMPLE *thisSound;
	string		  finalPath;
	soundInfo_t   *worldID   = new soundInfo_t;

	// see if the sound is allready loaded
	for(int i = 0; i < worldSounds.size(); i++)
	{
		if(!strcmp(filename,worldSounds.at(i)->soundName.c_str()))
			return i;
	}

	worldID->soundName  = filename;	
	// Construct the file path
	finalPath       = ".\\raw\\";
	finalPath.append(filename);

	thisSound = FSOUND_Sample_Load(FSOUND_FREE, finalPath.c_str(), FSOUND_UNSIGNED | FSOUND_8BITS | FSOUND_FORCEMONO | FSOUND_LOADRAW, 0, 0);

//	thisSound = FSOUND_Stream_Open(finalPath.c_str(), FSOUND_2D | FSOUND_LOADRAW,0,0);

	if(!thisSound)
	{
		printf("SoundManager: Failed to load sound %s\n",finalPath.c_str());
		return -1;
	}

	FSOUND_Sample_SetDefaults(thisSound,11025,-1,-1,-1);

	worldSounds.push_back(worldID);
	cachedSounds.push_back(thisSound);
	return worldSounds.size()-1;
}

/*
===========================================
void soundManager_t::soundPlay(int sndID)
===========================================
*/

void soundManager_t::soundPlay(int sndID)
{
	if(sndID > cachedSounds.size())
	{
		printf("WARNING: Sound %d is out of bounds(%d)\n",sndID,cachedSounds.size());
	}
	//if(!FSOUND_SetFrequency(FSOUND_ALL,11025))
	//	printf("WARNING: Set frequency failed\n");
	FSOUND_PlaySound(FSOUND_FREE,cachedSounds.at(sndID));
}

/*
====================================
int cacheMusic(char *filename)
====================================
*/

int soundManager_t::cacheMusic(char *filename)
{
	FMUSIC_MODULE *thisSong;
	string		  finalPath;
	soundInfo_t   *worldID   = new soundInfo_t;

	// see if the sound is allready loaded
	for(int i = 0; i < worldSounds.size(); i++)
	{
		if(!strcmp(filename,worldSounds.at(i)->soundName.c_str()))
			return i;
	}

	worldID->soundName  = filename;

	// Construct the file path
	finalPath       = ".\\mid\\";
	finalPath.append(filename);
	finalPath.append(".mid");

	// DEBUG only remove in non testing builds
	//printf(".....Loading song %s\n",finalPath.c_str());

	thisSong = FMUSIC_LoadSong(finalPath.c_str());

	if(!thisSong)
	{
		thisGame->Error("Failed to load a required music file\n");
	}
	
	// ID's for these two must be the same
	cachedMusic.push_back(thisSong);
	worldSounds.push_back(worldID);
	return cachedMusic.size()-1;
}

/*
=============================================
void soundManager_t::PlayMusic(int musicID)
=============================================
*/

void soundManager_t::PlayMusic(int musicID)
{
	FMUSIC_PlaySong(cachedMusic.at(musicID));
}