// threadManager.cpp

#include "game.h"
#include "script_runner.h"

char     *progBuffer;
int      spriteNum1 = -1;
/*
======================================
thread_t::thread_t()
======================================
*/

thread_t::thread_t(program_t *thisFunc)
{
	this->thisFunc = thisFunc;

	if(thisFunc->progSize < 5)
	{
		printf("threadManager: Invalid program size < 5\n");
		delete this;
		return;
	}

	threadRunning = false;
}

/*
================================================
void thread_t::ThreadCallFunc(string program)
================================================
*/
DWORD WINAPI ThreadCallFunc1( LPVOID lpParam ) 
{
	char *thisBuffer = progBuffer;
	script_runner    *thisProgram = new script_runner(progBuffer);

	srand(time(NULL));
	thisProgram->spriteNum = *(int*)lpParam;
	thisProgram->Execute();

	return NULL;
}

/*
================================================
void thread_t::ModifyProgram(char *newProgram)
================================================
*/

void thread_t::ModifyProgram(char *newProgram)
{
	progBuffer = newProgram;
}

/*
=========================================
char *thread_t::GetCurrentProgram(void)
=========================================
*/

char *thread_t::GetCurrentProgram(void)
{
	return progBuffer;
}

/*
================================
void thread_t::RunProgram(void)
================================
*/

void thread_t::RunProgram(void)
{
	progBuffer = (char *)thisFunc->progBuffer.c_str();

	if(threadRunning == false)
		threadRunning = true;
	else
		return;
	if(hThread) // thread was created allready, so resume it
	{
		ResumeThread(hThread);
	}

	hThread    = CreateThread(NULL,0,ThreadCallFunc1,&thisEntNum,0,&dwThreadId);               
 
	// Check the return value for success. 
	 
	if (hThread == NULL) 
	{
		printf( "RunProgram: CreateThread failed %d\n", GetLastError() ); 
	}
}

/*
=====================================
void thread_t::WaitFor_Thread(void)
=====================================
*/

void thread_t::WaitFor_Thread(void)
{
	HANDLE waitThreads[1];
	DWORD  WaitResult = WAIT_OBJECT_0+1;
	waitThreads[0] = hThread;

	while(WaitResult == WAIT_OBJECT_0+1)
	{
		if(WaitResult = MsgWaitForMultipleObjects(1,waitThreads,FALSE, INFINITE,QS_ALLINPUT) == WAIT_FAILED)
			printf("WARNING: System is contiuing even though child process is running\n");
	}
}

/*
=====================================
void thread_t::ShutdownThread(void)
=====================================
*/

void thread_t::ShutdownThread(void)
{
	threadRunning = false;
	SuspendThread(hThread);
}


