// threads.h

struct program_t
{
	string         progBuffer;
	int			   progSize;

	// Simply reads the entire script into memory
	// syntax checking does not get done till runtime.

	program_t::program_t(string scriptName)
	{
		FILE     *thisFile;
		buffer32 thisBuffer;
		string   thisFilePath = fileManager->fileAddPath("scripts",scriptName);

        thisFile = fopen(thisFilePath.c_str(),"rb");
		if(!thisFile)
		{
			printf("WARNING: Failed to open a requrired script %s\n", thisFilePath.c_str());
			return;
		}

		fseek(thisFile,0,SEEK_END);
		this->progSize = ftell(thisFile);
		fseek(thisFile,0,SEEK_SET);

		thisBuffer = (buffer32)malloc(this->progSize);

        fread(thisBuffer,this->progSize,1,thisFile);

		progBuffer = thisBuffer;

		fclose(thisFile);
	}
};

class thread_t
{
	public:
		thread_t::thread_t(program_t *thisFunc);

		void ShutdownThread(void);
		void RunProgram(void);
		void WaitFor_Thread(void);
		void ModifyProgram(char *newProgram);
		char *GetCurrentProgram(void);
		int thisEntNum;
	protected:
		DWORD WINAPI ThreadCallFunc( LPVOID lpParam );

		DWORD     dwThreadId;
		HANDLE    hThread; 
		program_t *thisFunc;

		boolean   threadRunning;
};