//-------------------------------------------------------------------------
/*
Copyright (C) 2005 - Justin Marshall

This file is part of the blood reconstruction project.

WinBlood is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

PORTIONS OF CODE FROM DUKE NUKEM 3D SOURCE CODE
*/
//-------------------------------------------------------------------------
// guiManager.cpp

#include "game.h"

/*
==========================================================
void guiManager::Blood_PrintfTimed(char *text, int time)
==========================================================
*/

void guiManager::Blood_PrintfTimed(char *text, int time)
{
	thread_t  *textTimedThread;
	program_t *textProg          = new program_t;

	textProg->progBuffer         = thread_DrawTimedText(text,time);
	textProg->progSize			 = textProg->progBuffer.size();

	textTimedThread              = new thread_t(textProg);

	textTimedThread->RunProgram();
}

/*
===================================================================
void guiManager::DrawText(char *text, int fontTile, int x, int y)
===================================================================
*/

void guiManager::Blood_Printf(char *text, int fontTile, int fontTile2, int shade, int dist, int x, int y)
{
	int startFont = fontTile;
	int i = 0;
	int charTile  = -1;
	int startChar = 97;
	int startChar1 = 48;
	try
	{
		for(i = 0; i < strlen(text); i++)
		{
			if(text[i] >= 48 && text[i] <= 59)
				charTile = fontTile2 + (text[i] - startChar1);
			else if(text[i] == '.')
				return;
			else
				charTile = startFont + (text[i] - startChar);
			build_func->rotatesprite((x + (i*dist))<<16,y<<16,65536L,0,charTile,shade,0,10,0,0,800-1,600-1);
		}
	}
	catch(...)
	{

	}
}

/*
=====================================================
void guiManager::DrawText(char *text, int x, int y)
=====================================================
*/

void guiManager::DrawText(char *text, int fontTile, int x, int y)
{
	int startFont = fontTile;
	int i = 0;
	int charTile  = -1;
	int startChar = 97;
	int dist = 10;

	if(fontTile == 4417)
		dist = 6;
	
	for(i = 0; i < strlen(text); i++)
	{
		charTile = startFont + (text[i] - startChar);
		build_func->rotatesprite((x + (i*dist))<<16,y<<16,65536L,0,charTile,16,0,10,0,0,800-1,600-1);
	}
}

/*
=====================================================
void guiManager::DrawTextNoFlash(char *text, int x, int y)
=====================================================
*/

void guiManager::DrawTextNoFlash(char *text, int x, int y)
{
	int startFont = 4257;
	int i = 0;
	int charTile  = -1;
	int startChar = 97;
	
	for(i = 0; i < strlen(text); i++)
	{
		charTile = startFont + (text[i] - startChar);
		build_func->rotatesprite((x + (i*10))<<16,y<<16,65536L,0,charTile,1,0,10,0,0,800-1,600-1);
	}
}

/*
===========================================================
void guiManager::DrawTextLight(char *text, int fontTile, int x, int y)
===========================================================
*/
void guiManager::DrawTextLight(char *text, int fontTile, int x, int y)
{
	int startFont = fontTile;//= 4257;
	int i = 0;
	int charTile  = -1;
	int startChar = 97;
	int dist = 10;

	if(fontTile == 4417)
		dist = 6;
	
	for(i = 0; i < strlen(text); i++)
	{
		charTile = startFont + (text[i] - startChar);
		build_func->rotatesprite((x + (i*dist))<<16,y<<16,65536L,0,charTile,((6+(build_func->ftotalclock()>>2))%13),0,10,0,0,800-1,600-1);
	}
}

/*
=====================================================
void guiManager::DrawText(char *text, int x, int y)
=====================================================
*/

void guiManager::DrawTextCustom(char *text, long startFont, int shade, int x, int y)
{
	int i = 0;
	int charTile  = -1;
	int startChar = 48;
	int dist = 10;

	if(startFont == 4417 || startFont == 4400)
		dist = 6;
	
	for(i = 0; i < strlen(text); i++)
	{
		charTile = startFont + (text[i] - startChar);
		build_func->rotatesprite((x + (i*dist))<<16,y<<16,65536L,0,charTile,shade,0,10,0,0,800-1,600-1);
	}
}

/*
=====================================================
void guiManager::DrawText(char *text, int x, int y)
=====================================================
*/

void guiManager::DrawTextCustom2(char *text, long startFont, int shade, int x, int y)
{
	int i = 0;
	int charTile  = -1;
	int startChar = 97;
	
	try
	{
		for(i = 0; i < strlen(text); i++)
		{
			charTile = startFont + (text[i] - startChar);
			build_func->rotatesprite((x + (i*10))<<16,y<<16,65536L,0,charTile,shade,0,10,0,0,800-1,600-1);
		}
	}
	catch(...)
	{

	}
}

/*
DrawTile

Draws a tile on the screen
*/

void guiManager::DrawTile(int tilenum, int x, int y, int width, int height)
{
	build_func->rotatesprite(width<<15,height<<15,65536L,0,tilenum,0,0,2+8+64,0,0,800-1,600-1);
}

/*
DrawFullHud

Draws the hud to the screen, which needs to be done special
*/
void guiManager::DrawFullHud(long x1,long y1,long x2,long y2)
{
	//build_func->rotatesprite(0,(200-34)<<16,65536L,0,STATUSBAR,0,0,2+8+64,build_func->scale(x1,xdim,320),build_func->scale(y1,ydim,200),build_func->scale(x2,xdim,320),build_func->scale(y2,ydim,200)-1);
}



/*
void guiManager::PrepareGUI(void)

Prepares the 2D gui
*/
void guiManager::PrepareGUI(void)
{
	build_func->nextpage();
	build_func->clearview(0L);
}
/*
void guiManager::2DInit(void)

Starts the 2D gui system
*/
void guiManager::Init2D(void)
{
	this->PrepareGUI();
}

/*
void guiManager::DrawLoading(char *board))

Draws a loading screen
*/
void guiManager::DrawLoading(char *board)
{
	this->DrawTile(MENUBK,0,0,320,200);
}