//-------------------------------------------------------------------------
/*
Copyright (C) 2005 - Justin Marshall

This file is part of the blood reconstruction project.

WinBlood is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

updatesectorZ from Shadow Warrior
*/
//-------------------------------------------------------------------------

// rooms.cpp

#include "game.h"

/*
================================================
short sectorManager_t::findSosMe(long sectnum)
================================================
*/


short sectorManager_t::findSosMe(long sectnum)
{
	spritetype *thisSprite;

	for(int i = 0; i < thisGame->numofsprites; i++)
	{
		thisSprite = build_func->Game_GetSprite(i);

		if(thisSprite->sectnum == sectnum && (thisSprite->picnum == SOSUP || thisSprite->picnum == SOSDOWN))
			return i;
	}
	return -1;
}
/*
=======================================================
short sectorManager_t::findSosFriendSect(long sectnum)
=======================================================
*/

short sectorManager_t::findSosFriendSect(long sectnum)
{
	spritetype  *thisSprite, *friendSprite;
	xspritetype *xsprite, *xsprite2;

	for(int i = 0; i < thisGame->numofsprites; i++)
	{
		thisSprite = build_func->Game_GetSprite(i);

		if(thisSprite->sectnum == sectnum && (thisSprite->picnum == SOSUP || thisSprite->picnum == SOSDOWN))
		{
			xsprite = build_func->GetXSprite(i);

			for(int j = 0; j < thisGame->numofsprites; j++)
			{
				xsprite2     = build_func->GetXSprite(j);
				
				if(xsprite2->data1 == xsprite->data1)
				{
					friendSprite = build_func->Game_GetSprite(j);

					switch(thisSprite->picnum)
					{
						case SOSUP:
							if(friendSprite->picnum == SOSDOWN)
								return j;
						break;
						case SOSDOWN:
							if(friendSprite->picnum == SOSUP)
								return j;
						break;
					}
				}
			}
		}
	}

	// No sos found
	return -1;
}

/*
=============================================================================
void sectorManager_t::updateSectorz(long x, long y, long z, short *sectnum)
=============================================================================
*/

void sectorManager_t::updateSectorz(long x, long y, long z, short *sectnum)
{

	if(*sectnum < 0 || *sectnum > thisGame->numSectors)
		exit(0);

	
}