//-------------------------------------------------------------------------
/*
Copyright (C) 2005 - Justin Marshall

This file is part of the blood reconstruction project.

WinBlood is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

PORTIONS OF CODE FROM DUKE NUKEM 3D SOURCE CODE
*/
//-------------------------------------------------------------------------
// threads.h

struct program_t
{
	string         progBuffer;
	int			   progSize;

	program_t::program_t()
	{
		
	}

	// Simply reads the entire script into memory
	// syntax checking does not get done till runtime.

	program_t::program_t(string scriptName)
	{
		FILE     *thisFile;
		buffer32 thisBuffer;
		string   thisFilePath = fileManager->fileAddPath("scripts",scriptName);

        thisFile = fopen(thisFilePath.c_str(),"rb");
		if(!thisFile)
		{
			printf("WARNING: Failed to open a requrired script %s\n", thisFilePath.c_str());
			return;
		}

		fseek(thisFile,0,SEEK_END);
		this->progSize = ftell(thisFile);
		fseek(thisFile,0,SEEK_SET);

		thisBuffer = (buffer32)malloc(this->progSize);

        fread(thisBuffer,this->progSize,1,thisFile);

		progBuffer = thisBuffer;

		fclose(thisFile);
	}
};

class thread_t
{
	public:
		thread_t::thread_t(program_t *thisFunc);

		void ShutdownThread(void);
		void RunProgram(void);
		void RunProgram1(void);
		void WaitFor_Thread(void);
		void ModifyProgram(char *newProgram);
		void KillThread(void);
		char *GetCurrentProgram(void);
		int thisEntNum;
	protected:
		DWORD WINAPI ThreadCallFunc( LPVOID lpParam );

		DWORD     dwThreadId;
		HANDLE    hThread; 
		program_t *thisFunc;

		boolean   threadRunning;
};